VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CWIMImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_sFilePath         As String
Private m_sTempPath         As String
Private m_bTempChanged      As Boolean
Private m_sApplyPath        As String
Private m_hWimFile          As OLE_HANDLE
Private m_hCurImage         As OLE_HANDLE
Private m_pAbortFlagAddr    As Long

Public Property Let AbortFlagAddress( _
                    ByVal pValue As Long)
    m_pAbortFlagAddr = pValue
End Property
Public Property Get AbortFlagAddress() As Long
    AbortFlagAddress = m_pAbortFlagAddr
End Property

Public Property Get FilePath() As String
    FilePath = m_sFilePath
End Property

Public Property Let TempPath( _
                    ByRef sValue As String)
    
    If m_hWimFile Then
    
        If WIMSetTemporaryPath(m_hWimFile, StrPtr(sValue)) = 0 Then
            PutLog "WIMSetTemporaryPath failed " & Err.LastDllError & "  " & ErrMessageText(Err.LastDllError)
            Err.Raise 7
        End If
        
        m_bTempChanged = False
        
    Else
        m_bTempChanged = True
    End If
    
    m_sTempPath = sValue
    
End Property
Public Property Get TempPath() As String
    TempPath = m_sTempPath
End Property

Public Property Let ApplyPath( _
                    ByRef sValue As String)
    m_sApplyPath = sValue
End Property
Public Property Get ApplyPath() As String
    ApplyPath = m_sApplyPath
End Property

Public Property Get Information() As String
    Dim pImageInfo      As Long
    Dim lImageInfoSize  As Long
    
    If m_hWimFile = 0 Then
        Err.Raise 5
    End If
    
    If WIMGetImageInformation(m_hWimFile, pImageInfo, lImageInfoSize) Then
    
        If pImageInfo <> 0 And lImageInfoSize > 0 Then
            
            PutMem4 ByVal VarPtr(Information), SysAllocStringByteLen(ByVal pImageInfo, lImageInfoSize)
            
        End If
        
        LocalFree pImageInfo
        
    Else
        Err.Raise 7
    End If
    
End Property

Public Sub LoadFile( _
           ByRef sPath As String)
                    
    CloseAll
                    
    m_hWimFile = WIMCreateFile(StrPtr(sPath), WIM_GENERIC_READ, WIM_OPEN_EXISTING, 0, WIM_COMPRESS_NONE, 0)
    
    If m_hWimFile = 0 Then
        PutLog "WIMCreateFile failed " & Err.LastDllError & "  " & ErrMessageText(Err.LastDllError)
        Err.Raise 7
    End If
               
    m_sFilePath = sPath
               
End Sub

Public Sub LoadImage( _
           ByVal lOneBaseImgIndex As Long)
    Dim hImage  As OLE_HANDLE
    
    If m_hWimFile = 0 Then
        Err.Raise 5
    End If
    
    If m_bTempChanged Then
    
        If WIMSetTemporaryPath(m_hWimFile, StrPtr(m_sTempPath)) = 0 Then
            PutLog "WIMSetTemporaryPath failed " & Err.LastDllError & "  " & ErrMessageText(Err.LastDllError)
            Err.Raise 7
        End If
        
        m_bTempChanged = False
        
    End If
    
    hImage = WIMLoadImage(m_hWimFile, lOneBaseImgIndex)
    
    If hImage = 0 Then
        PutLog "WIMLoadImage failed " & Err.LastDllError & "  " & ErrMessageText(Err.LastDllError)
        Err.Raise 7
    End If
            
    If m_hCurImage Then
        WIMCloseHandle m_hCurImage
    End If
            
    m_hCurImage = hImage
    
End Sub

Public Sub Apply()
    Dim bIsInIDE    As Boolean
    Dim pfnCallback As Long
    
    Debug.Assert PutMem2(bIsInIDE, -1) = 0
    
    If m_hWimFile = 0 Or m_hCurImage = 0 Then
        Err.Raise 5
    End If
    
    If Len(m_sApplyPath) = 0 Or Len(m_sTempPath) = 0 Then
        Err.Raise 5
    End If
    
    PutLog "Start"
    
    If Not bIsInIDE Then
        If WIMRegisterMessageCallback(m_hWimFile, AddressOf WIMMessageCallback, m_pAbortFlagAddr) = INVALID_CALLBACK_VALUE Then
            PutLog "WIMRegisterMessageCallback failed " & Err.LastDllError & "  " & ErrMessageText(Err.LastDllError)
            Err.Raise 7
        End If
    End If
    
    If WIMApplyImage(m_hCurImage, StrPtr(m_sApplyPath), WIM_FLAG_VERIFY Or WIM_FLAG_NO_RP_FIX Or WIM_FLAG_NO_DIRACL Or WIM_FLAG_NO_FILEACL) = 0 Then
        tErrNumber = 0: tErrDescrt = "": tErrNumber = Err.LastDllError: tErrDescrt = ErrMessageText(tErrNumber)
        
        PutLog "WIMApplyImage failed " & tErrNumber & "  " & tErrDescrt
        Err.Raise 7, "source", "Description", "HelpFile", "HelpContext"
        
    End If
    
    If Not bIsInIDE Then
        WIMUnregisterMessageCallback m_hWimFile, AddressOf WIMMessageCallback
    End If
    
    PutLog "Finish"
    
End Sub

Private Sub CloseAll()
    
    If m_hCurImage Then
        WIMCloseHandle m_hCurImage
        m_hCurImage = 0
    End If
    
    If m_hWimFile Then
        WIMCloseHandle m_hWimFile
        m_hWimFile = 0
    End If
    
End Sub

Private Sub Class_Terminate()
    CloseAll
End Sub
