Attribute VB_Name = "modMain"
Option Explicit

Public Const MAX_PATH                As Long = 260

Public Const BIF_RETURNONLYFSDIRS    As Long = &H1&
Public Const BIF_NEWDIALOGSTYLE      As Long = &H40

Public Const WIM_MSG_SUCCESS         As Long = &H0
Public Const WIM_MSG_PROGRESS        As Long = 38008
Public Const WIM_MSG_PROCESS         As Long = 38009
Public Const WIM_MSG_ERROR           As Long = 38015
Public Const WIM_MSG_STEPIT          As Long = 38013
Public Const WIM_MSG_SETPOS          As Long = 38012
Public Const WIM_MSG_ABORT_IMAGE     As Long = &HFFFFFFFF
Public Const INVALID_CALLBACK_VALUE  As Long = &HFFFFFFFF

Public Const WIM_GENERIC_READ        As Long = &H80000000
Public Const WIM_OPEN_EXISTING       As Long = &H3

Public Const WIM_COMPRESS_NONE       As Byte = 0

Public Const WIM_FLAG_NO_RP_FIX      As Long = &H100
Public Const WIM_FLAG_VERIFY         As Long = &H2
' Disables restoring security information for directories.
Public Const WIM_FLAG_NO_DIRACL   As Long = &H10

' Disables restoring security information for files
Public Const WIM_FLAG_NO_FILEACL   As Long = &H20

Public Type OPENFILENAME
    lStructSize         As Long
    hwndOwner           As Long
    hInstance           As Long
    lpstrFilter         As Long
    lpstrCustomFilter   As Long
    nMaxCustFilter      As Long
    nFilterIndex        As Long
    lpstrFile           As Long
    nMaxFile            As Long
    lpstrFileTitle      As Long
    nMaxFileTitle       As Long
    lpstrInitialDir     As Long
    lpstrTitle          As Long
    flags               As Long
    nFileOffset         As Integer
    nFileExtension      As Integer
    lpstrDefExt         As Long
    lCustData           As Long
    lpfnHook            As Long
    lpTemplateName      As Long
End Type

Public Type BROWSEINFO
    hOwner              As Long
    pidlRoot            As Long
    pszDisplayName      As Long
    lpszTitle           As Long
    ulFlags             As Long
    lpCallbackProc      As Long
    lParam              As Long
    iImage              As Long
End Type

Public Type CRITICAL_SECTION
    pDebugInfo          As Long
    LockCount           As Long
    RecursionCount      As Long
    OwningThread        As Long
    LockSemaphore       As Long
    SpinCount           As Long
End Type

Public Type tWIMMessageCallbackParams
    dwMessageId         As Long
    wParam              As Long
    lParam              As Long
    pvUserData          As Long
End Type

Public Declare Function GetMem4 Lib "msvbvm60" ( _
                        ByRef SrcAddr As Any, _
                        ByRef Dst As Any) As Long
Public Declare Function PutMem4 Lib "msvbvm60" ( _
                        ByRef DstAddr As Any, _
                        ByVal lVal As Long) As Long
Public Declare Function PutMem2 Lib "msvbvm60" ( _
                        ByRef DstAddr As Any, _
                        ByVal lVal As Integer) As Long

Public Declare Function GetOpenFileName Lib "comdlg32.dll" _
                        Alias "GetOpenFileNameW" ( _
                        ByRef pOpenfilename As OPENFILENAME) As Long
Public Declare Function SHBrowseForFolder Lib "shell32.dll" _
                        Alias "SHBrowseForFolderW" ( _
                        ByRef lpBrowseInfo As BROWSEINFO) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" _
                        Alias "SHGetPathFromIDListW" ( _
                        ByVal pidl As Long, _
                        ByVal pszPath As Long) As Long
 Public Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                   ByVal pv As Long)
Public Declare Function PathFileExists Lib "Shlwapi" _
                        Alias "PathFileExistsW" ( _
                        ByVal pszPath As Long) As Long
Public Declare Function LocalFree Lib "kernel32" ( _
                        ByVal hMem As Long) As Long
 Public Declare Function SysAllocString Lib "oleaut32" ( _
                        ByRef pOlechar As Any) As Long
Public Declare Function SysAllocStringByteLen Lib "oleaut32" ( _
                        ByRef m_pBase As Any, _
                        ByVal llen As Long) As Long
Public Declare Function InitializeCriticalSection Lib "kernel32" ( _
                        ByRef lpCriticalSection As CRITICAL_SECTION) As Long
Public Declare Sub EnterCriticalSection Lib "kernel32" ( _
                   ByRef lpCriticalSection As CRITICAL_SECTION)
Public Declare Sub LeaveCriticalSection Lib "kernel32" ( _
                   ByRef lpCriticalSection As CRITICAL_SECTION)
Public Declare Sub DeleteCriticalSection Lib "kernel32" ( _
                   ByRef lpCriticalSection As CRITICAL_SECTION)
Public Declare Function WIMCloseHandle Lib "WIMGAPI.DLL" ( _
                        ByVal hObject As Long) As Boolean

Public Declare Function WIMCreateFile Lib "WIMGAPI.DLL" ( _
                        ByVal lpszWimPath As Long, _
                        ByVal dwDesiredAccess As Long, _
                        ByVal dwCreationDisposition As Long, _
                        ByVal dwFlagsAndAttributes As Long, _
                        ByVal dwCompressionType As Long, _
                        ByRef CreationResult As Long) As Long
   
Public Declare Function WIMGetImageInformation Lib "WIMGAPI.DLL" ( _
                        ByVal hImage As Long, _
                        ByRef ppvImageInfo As Any, _
                        ByRef pcbImageInfo As Long) As Long

Public Declare Function WIMSetTemporaryPath Lib "WIMGAPI.DLL" ( _
                        ByVal hWim As Long, _
                        ByVal lpszPath As Long) As Boolean

Public Declare Function WIMLoadImage Lib "WIMGAPI.DLL" ( _
                        ByVal hWim As Long, _
                        ByVal dwImageIndex As Long) As Long

Public Declare Function WIMApplyImage Lib "WIMGAPI.DLL" ( _
                        ByVal hImage As Long, _
                        ByVal lpszPath As Long, _
                        ByVal dzApplyFlags As Long) As Boolean

Public Declare Function WIMRegisterMessageCallback Lib "WIMGAPI.DLL" ( _
                        ByVal hWim As Long, _
                        ByVal fpMessageProc As Long, _
                        ByVal pvUserData As Long) As Long
   
Public Declare Function WIMUnregisterMessageCallback Lib "WIMGAPI.DLL" ( _
                        ByVal hWim As Long, _
                        ByVal fpMessageProc As Long) As Boolean

Private m_sLogBuffer    As String               ' // Log text buffer
Private m_tLogLock      As CRITICAL_SECTION     ' // Critical section lock

Private m_tParamLock    As CRITICAL_SECTION     ' // Critical section lock
Private m_tParam1
Private m_tParam2
Private m_tParam3
Private m_tParam4
Private m_tParam5


' // Marshal stream. A threads uses that data to unmarshal frmMain object in different threads
Public gpMarshalData    As Long



' // Initialize Log
Public Sub InitLog()
    InitializeCriticalSection m_tLogLock
    InitializeCriticalSection m_tParamLock
End Sub

' // Uninitialize Log
Public Sub UninitLog()
    DeleteCriticalSection m_tLogLock
    DeleteCriticalSection m_tParamLock
End Sub

' // Add log entry
Public Sub PutLog( _
           ByVal sText As String)
    EnterCriticalSection m_tLogLock
    m_sLogBuffer = m_sLogBuffer & Now & ": " & sText & vbNewLine
    LeaveCriticalSection m_tLogLock
End Sub

Public Sub PutParam(ByVal inParam1 As Long, ByVal inParam2 As Long, ByVal inParam3 As Long, ByVal inParam4 As Long, ByVal inParam5 As Long)
'Public Sub PutParam(ByVal inParam1 As Long, ByVal inParam2 As Long, ByVal inParam3 As Long)
    EnterCriticalSection m_tParamLock
    m_tParam1 = inParam1
    m_tParam2 = inParam2
    m_tParam3 = inParam3
    m_tParam4 = inParam4
    m_tParam5 = inParam5
    LeaveCriticalSection m_tParamLock
End Sub



' // Extract log buffer and free it
Public Function ExtractParam(ByRef outParam2 As Long, ByRef outParam3 As Long, ByRef outParam4 As Long, ByRef outParam5 As Long) As Long
'Public Function ExtractParam(ByRef outParam2 As Long, ByRef outParam3 As Long) As Long
    EnterCriticalSection m_tParamLock

    ExtractParam = m_tParam1
    outParam2 = m_tParam2
    outParam3 = m_tParam3
    outParam4 = m_tParam4
    outParam5 = m_tParam5
    
    m_tParam1 = 0
    m_tParam2 = 0
    m_tParam3 = 0
    m_tParam4 = 0
    m_tParam5 = 0
    
    LeaveCriticalSection m_tParamLock
End Function


' // Extract log buffer and free it
Public Function ExtractLog() As String
    EnterCriticalSection m_tLogLock
    ExtractLog = m_sLogBuffer
    m_sLogBuffer = vbNullString
    LeaveCriticalSection m_tLogLock
End Function

' // Show open-folder dialog
Public Function BrowseFolder( _
                ByVal hwnd As Long, _
                ByRef sTitle As String) As String
    Dim tBI     As BROWSEINFO
    Dim pidlRet As OLE_HANDLE
    
    tBI.hOwner = hwnd
    tBI.lpszTitle = StrPtr(sTitle)
    tBI.ulFlags = BIF_RETURNONLYFSDIRS Or BIF_NEWDIALOGSTYLE
    
    pidlRet = SHBrowseForFolder(tBI)
    
    If pidlRet Then
        
        BrowseFolder = Space$(MAX_PATH)
        
        If SHGetPathFromIDList(pidlRet, StrPtr(BrowseFolder)) Then
            BrowseFolder = Left$(BrowseFolder, InStr(1, BrowseFolder, vbNullChar) - 1)
        Else
            BrowseFolder = vbNullString
        End If
        
        CoTaskMemFree pidlRet
        
    End If

End Function

' // Show open-file dialog
Public Function GetOpenFile( _
                ByVal hwnd As Long, _
                ByRef sTitle As String, _
                ByRef sFilter As String) As String
    Dim tOfn            As OPENFILENAME
    Dim strInputFile    As String
    
    With tOfn
    
        .nMaxFile = 260
        strInputFile = String$(.nMaxFile, vbNullChar)
        
        .hwndOwner = hwnd
        .lpstrTitle = StrPtr(sTitle)
        .lpstrFile = StrPtr(strInputFile)
        .lStructSize = Len(tOfn)
        .lpstrFilter = StrPtr(sFilter)
        
        If GetOpenFileName(tOfn) = 0 Then Exit Function
        
        GetOpenFile = Left$(strInputFile, InStr(1, strInputFile, vbNullChar) - 1)
        
    End With

End Function

Public Function WIMMessageCallback( _
                ByVal dwMessageId As Long, _
                ByVal wParam As Long, _
                ByVal lParam As Long, _
                ByVal pvUserData As Long) As Long
    InitCurrentThreadAndCallFunction AddressOf WIMMessageCallback2, VarPtr(dwMessageId), WIMMessageCallback
    
End Function

' // This function is called from different threads with the initialized runtime
Public Function WIMMessageCallback2( _
                ByRef tParams As tWIMMessageCallbackParams) As Long
    
    Dim bAbort  As Boolean
    Dim sText   As String
    
    
       
    Select Case tParams.dwMessageId
    Case WIM_MSG_PROCESS
        'PutMem4 ByVal VarPtr(sText), SysAllocString(ByVal tParams.wParam)
        'PutLog "WIM_MSG_PROCESS: " & sText
    Case WIM_MSG_ERROR
        PutMem4 ByVal VarPtr(sText), SysAllocString(ByVal tParams.wParam)
        PutLog "WIM_MSG_ERROR: " & tParams.lParam & "; " & sText
    Case WIM_MSG_PROGRESS
        
        PutParam ByVal tParams.dwMessageId, tParams.wParam, tParams.lParam, tParams.pvUserData, App.ThreadID
        
        PutLog "WIM_MSG_PROGRESS: " & tParams.wParam & " / " & tParams.lParam
        
        
    Case WIM_MSG_STEPIT
        'PutLog "WIM_MSG_STEPIT"
    Case WIM_MSG_SETPOS
        PutLog "WIM_MSG_STEPIT: Count: " & tParams.lParam
    Case Else
        PutLog tParams.dwMessageId & " / " & tParams.wParam & " / " & tParams.lParam
    End Select

    ' // Check for abort
    ' // pvUserData contains address of bollean variable we can contol from the main thread
    GetMem4 ByVal tParams.pvUserData, bAbort

    If bAbort Then
        WIMMessageCallback2 = WIM_MSG_ABORT_IMAGE
    Else
        WIMMessageCallback2 = WIM_MSG_SUCCESS
    End If

    
    Dim cObj    As Object
    ' // Get unmarshaled pointer of frmMain
    Set cObj = UnMarshal(gpMarshalData, , False)

    cObj.clock
    
End Function

